const AWS = require('aws-sdk');
const { SERVICE_REGION, SELLER_ACCESS_KEY, SELLER_SECRET_KEY } = require('../../utils/consts');


function getSns() {
    return new AWS.SNS({ region: SERVICE_REGION, accessKeyId: SELLER_ACCESS_KEY, secretAccessKey: SELLER_SECRET_KEY });
}

async function subscribe(topicArn, queueArn) {
    const sns = getSns();
    const data = await sns.subscribe({
        Protocol: 'sqs',
        TopicArn: topicArn,
        Endpoint: queueArn
    }).promise();

    return data.SubscriptionArn;
}

async function confirmSubscription(topicArn, token) {
    const sns = getSns();
    const data = await sns.confirmSubscription({
        Token: token,
        TopicArn: topicArn
    }).promise();

    return data.SubscriptionArn;
}

module.exports = { subscribe, confirmSubscription };
