const { CLOUD_TIERING_NAMESPACE } = require('../utils/consts');
const { findAccount } = require('../operations/multi-tenancy-operation');

async function findAccountAndUpdateContinuationToken(req, res, next) {
    try { // find account for rest api and not for graphql apis
        if (!(req.path === '/graphql' || (req.body && req.body.operationName === 'IntrospectionQuery')
            || (req.path === '/api/statistics/account-exists'))) {
            const accountId = await findAccount(CLOUD_TIERING_NAMESPACE.get('userPortalId'));
            CLOUD_TIERING_NAMESPACE.set('accountId', accountId);
            next();
        } else {
            next();
        }
    } catch (err) {
        res.status(err.status || 500).send({ message: err.message, status: err.status });
    }
}

module.exports = findAccountAndUpdateContinuationToken;
