const mongoose = require('mongoose');
const bytes = require('bytes');
const { SAAS_REGISTRATION_STATUS_UNSUBSCRIBED_INIT } = require('../utils/consts');

const awsSubscriptionSchema = new mongoose.Schema({
    customerIdentifier: { type: String, required: false },
    status: { type: String, required: true, default: SAAS_REGISTRATION_STATUS_UNSUBSCRIBED_INIT },
    updatedAt: { type: Date, required: true, default: Date.now() }
}, { _id: false });

const accountSchema = new mongoose.Schema({
    name: { type: String, required: true },
    accountId: { type: String, required: true, index: true },
    trialExpiry: { type: Number, required: true, default: bytes('10TB') },
    awsSubscription: { type: awsSubscriptionSchema, required: true, default: {} }
}, {
    timestamps: true, // assign createdAt and updatedAt
    toJSON: {
        transform(doc, ret) {
            const toReturn = ret;
            delete toReturn.__v;
            return toReturn;
        }
    }
});


const Account = mongoose.model('Account', accountSchema);

module.exports = Account;
