const { ApolloError } = require('apollo-server');
const jwtVerifyAsync = require('../utils/jwt');
const { JWT_TOKEN_API_AUTH0_AUDIENCE, CLOUD_TIERING_NAMESPACE } = require('../utils/consts');

async function authenticate(token) {
    if (!token) {
        throw new Error('No authentication token provided');
    }
    try {
        const payload = await jwtVerifyAsync(token, JWT_TOKEN_API_AUTH0_AUDIENCE);
        CLOUD_TIERING_NAMESPACE.set('userPortalId', payload.sub);
        CLOUD_TIERING_NAMESPACE.set('userToken', token);
        CLOUD_TIERING_NAMESPACE.set('userName', payload['http://cloud.netapp.com/full_name']);
    } catch (err) {
        throw new ApolloError('UNAUTHORIZED', 401);
    }
}

module.exports = authenticate;
