const signLicense = require('../lib/ipa');
const { applyLicense } = require('../lib/cloud-manager/clusters');
const getLogger = require('../utils/logger/logger');

const logger = getLogger();

async function generateLicense(capacity, clusterId) {
    const fabricPoolLicense = {
        serialNumber: '22654892', version: '1', product: 'fabricpool', licenses: { capacity, type: 'capacity', package: 'FabricPool' }
    };
    logger.info(`About to generate signed license ${JSON.stringify(fabricPoolLicense)} on clusterId ${clusterId}`);
    return signLicense(fabricPoolLicense);
}

async function createLicenseAndApply(clusterId, licenseCapacity) {
    const license = await generateLicense(licenseCapacity, clusterId);
    logger.info(`About to apply license ${JSON.stringify(license)} on cluster ${clusterId}`);
    return applyLicense(clusterId, license);
}

module.exports = createLicenseAndApply;
