const express = require('express');
const { escape } = require('querystring');
const getLogger = require('../utils/logger/logger');
const { API_PATH_SAAS_REGISTRATION } = require('../utils/consts');

const saasRegistrationRouter = express.Router();
const logger = getLogger();

saasRegistrationRouter.post(`${API_PATH_SAAS_REGISTRATION}`, (req, res) => {
    const token = escape(req.body['x-amzn-marketplace-token']);
    if (token) {
        res.redirect(`/?rt=${token}`);
    } else {
        logger.warn(`Landed on ${API_PATH_SAAS_REGISTRATION} page without a token`);
        res.redirect('/');
    }
});

module.exports = saasRegistrationRouter;
