const Joi = require('joi');
const getLogger = require('./logger/logger');

const logger = getLogger();

function validateSchema(data, schema, allowUnknown = false) {
    const result = Joi.validate(data, schema, { allowUnknown });
    if (result.error) {
        logger.error('Schema Validation error', result.error);
        throw result.error;
    }
}

function validateResponse(data, schema) {
    validateSchema(data, schema, true);
}

function validateRequest(data, schema) {
    validateSchema(data, schema, false);
}


module.exports = { validateRequest, validateResponse, validateSchema };
