const bytes = require('bytes');
const { cloneDeep } = require('lodash');

function hideToken(response) {
    const responseCloned = cloneDeep(response);
    Object.keys(responseCloned).forEach(key => {
        if (['access_token', 'client_secret'].includes(key)) {
            responseCloned[key] = '******';
        }
    });
    return responseCloned;
}

function capacityToBytes(capacity) {
    if (capacity) {
        return bytes(`${capacity.size}${capacity.unit}`);
    }
    return 0;
}

module.exports = {
    hideToken, capacityToBytes
};
