const nock = require('nock');
const { loadScenario, loadScenrioForUser } = require('../simulator-state');
const { findUserId } = require('../simulator-utils');
const getLogger = require('../../../src/utils/logger/logger');

const logger = getLogger('simulator');

const internalScope = nock('https://127.0.0.1:8888')
    .log(evt => logger.info(evt))
    .post('/simulator/change-scenario', requestBody => requestBody.scenario)
    .reply(function (uri, requestBody) {
        const body = JSON.parse(requestBody);
        if (body.scenario) {
            const { authorization } = this.req.headers;
            if (authorization !== '') {
                const userId = findUserId(authorization);
                loadScenrioForUser(body.scenario, userId);
            } else {
                loadScenario(body.scenario);
            }
            return [200, { scenario: body.scenario }];
        }
        return [404];
    });

internalScope.persist(true);

module.exports = internalScope;
