const nock = require('nock');
const getLogger = require('../../../src/utils/logger/logger');
const { IPA_BASE_URL, IPA_SIGN_PATH } = require('../../../src/utils/consts');
const { escapeForwardSlash } = require('../simulator-utils');

const logger = getLogger('simulator');

const ipaScope = nock(IPA_BASE_URL)
    .log(evt => logger.info(evt))
    // POST signLicense
    .post(escapeForwardSlash(`${IPA_SIGN_PATH}`))
    .delay(100)
    .reply(200, (uri, requestBody) => {
        const license = JSON.parse(requestBody);
        const signedLicense = {
            statusResp: license,
            Signature: 'NNYegJSXa6wHxq2jHIVNNQCMN0',
            trackingId: 'OTC01902120808396800800'
        };
        return [200, signedLicense];
    });

ipaScope.persist(true);

module.exports = ipaScope;
