const nock = require('nock');
const getLogger = require('../../../src/utils/logger/logger');

const logger = getLogger('simulator');

const ec2Scope = nock('https://sts.amazonaws.com')
    .log(evt => logger.info(evt))
    // describe regions
    .post('/', body => body.Action === 'GetCallerIdentity')
    .delay(100)
    .reply(200, function () {
        const { authorization } = this.req.headers;
        if (authorization.includes('Credential=invalid')) {
            return [400, `
<GetCallerIdentityResponse xmlns="https://sts.amazonaws.com/doc/2011-06-15/">
        <Error>
            <Code>InvalidClientTokenId</Code>
            <Message>The resource you requested does not exist</Message>
            <RequestId>4442587FB7D0A2F9</RequestId>
            </Error>
</GetCallerIdentityResponse>`];
        }
        return `
<GetCallerIdentityResponse xmlns="https://sts.amazonaws.com/doc/2011-06-15/">
  <GetCallerIdentityResult>
   <Arn>arn:aws:iam::123456789012:user/Alice</Arn>
    <UserId>AIDACKCEVSQ6C2EXAMPLE</UserId>
    <Account>123456789012</Account>
  </GetCallerIdentityResult>
  <ResponseMetadata>
    <RequestId>01234567-89ab-cdef-0123-456789abcdef</RequestId>
  </ResponseMetadata>
</GetCallerIdentityResponse>`;
    });

ec2Scope.persist(true);
